package foele.jini.event;

import java.rmi.*;
/**
 * Insert the type's description here.
 * Creation date: (13/08/99 17.24.46)
 * @author: 
 */
public abstract class AbstractRemoteBeanEventFirer extends java.rmi.server.UnicastRemoteObject implements RemoteBeanEventFirer,foele.jini.lease.LeasedResource {
	private java.util.Map RemoteEventListeners=java.util.Collections.synchronizedMap(new java.util.HashMap());
	private foele.jini.lease.PluggablePolicyLeaseManager LeaseManager;
	private int seq = 0;
	
/**
 * AbstractRemoteEventFirer constructor comment.
 * @exception java.rmi.RemoteException The exception description.
 */
protected AbstractRemoteBeanEventFirer() throws java.rmi.RemoteException {
	super();
	LeaseManager = new foele.jini.lease.PluggablePolicyLeaseManager();
}
/**
 * AbstractRemoteEventFirer constructor comment.
 * @param port int
 * @exception java.rmi.RemoteException The exception description.
 */
protected AbstractRemoteBeanEventFirer(int port) throws java.rmi.RemoteException {
	super(port);
	LeaseManager = new foele.jini.lease.PluggablePolicyLeaseManager();
}
/**
 * AbstractRemoteEventFirer constructor comment.
 * @param port int
 * @param csf java.rmi.server.RMIClientSocketFactory
 * @param ssf java.rmi.server.RMIServerSocketFactory
 * @exception java.rmi.RemoteException The exception description.
 */
protected AbstractRemoteBeanEventFirer(int port, java.rmi.server.RMIClientSocketFactory csf, java.rmi.server.RMIServerSocketFactory ssf) throws java.rmi.RemoteException {
	super(port, csf, ssf);
	LeaseManager = new foele.jini.lease.PluggablePolicyLeaseManager();
}
/**
 * addRemoteBeanEventListener method comment.
 */
public net.jini.core.event.EventRegistration addRemoteBeanEventListener(net.jini.core.event.RemoteEventListener RemoteEventListener) throws net.jini.core.lease.LeaseDeniedException, java.rmi.RemoteException {
	net.jini.core.lease.Lease Lease=createNewLease(net.jini.core.lease.Lease.FOREVER);
	RemoteEventListeners.put(RemoteEventListener,Lease);
	return new net.jini.core.event.EventRegistration(RemoteBeanEvent.REMOTE_BEAN_EVENT,this,Lease,seq);
}
/**
 * Insert the method's description here.
 * Creation date: (13/08/99 17.41.12)
 * @return net.jini.core.lease.Lease
 * @param leaseFor long
 * @exception net.jini.core.lease.LeaseDeniedException The exception description.
 * @exception java.rmi.RemoteException The exception description.
 */
public net.jini.core.lease.Lease createNewLease(long leaseFor) throws net.jini.core.lease.LeaseDeniedException, java.rmi.RemoteException {
	return LeaseManager.createNewLease(leaseFor,this);
}
/**
 * Insert the method's description here.
 * Creation date: (13/08/99 17.26.57)
 * @param Method java.lang.reflect.Method
 * @param args java.lang.Object[]
 */
protected final void fireEvent(java.lang.reflect.Method Method, java.util.EventObject Event) {
	RemoteBeanEvent RBE=new RemoteBeanEvent(this,++seq,null,Method,new Object[] {Event});
	synchronized(RemoteEventListeners){
		java.util.Iterator i=RemoteEventListeners.keySet().iterator();
		while (i.hasNext()){
			net.jini.core.event.RemoteEventListener REL=(net.jini.core.event.RemoteEventListener)i.next();
			try {
				if (LeaseManager.isValid((net.jini.core.lease.Lease)RemoteEventListeners.get(REL)))
					REL.notify(RBE);
				else removeRemoteBeanEventListener(REL);
			}
			catch(Exception e){
				e.printStackTrace(System.out);
			}
		}
	}
				
		
}
/**
 * removeRemoteBeanEventListener method comment.
 */
public void removeRemoteBeanEventListener(net.jini.core.event.RemoteEventListener RemoteEventListener) throws java.rmi.RemoteException {
	RemoteEventListeners.remove(RemoteEventListener);
}
}
